#ifndef _MY_TEMPLATES_
#define _MY_TEMPLATES_
/*!
 * @brief useful templates
 * @authro Fujii Yasuhisa
 * @date 04/29/2009
 */

#include <iostream>
#include <sstream>
#include <queue>
#include <functional>

#include "my_typedefs.hpp"

namespace slp {
namespace spojus {
using namespace std;

/*!
 * @brief コンテナに格納されたポインタが指す先の領域を開放する
 * @param T cont ポインタを格納したコンテナ
 * @retval void
 */
template<class T> void ContainerFree(T &cont)
{
#if 0
	int count = 0;
#endif
	typename T::iterator iter;
	for (iter = cont.begin(); iter != cont.end(); ++ iter) {
#if 0
		cout << count ++ << ":" << *iter << flush;
#endif
		if (*iter != NULL) { delete *iter; }
#if 0
		cout << "\tok" << endl;
#endif
	}
	cont.clear();
}


/*!
 * @brief コンテナに格納されたポインタが指す先のベクトル領域を開放する
 * @param T cont ポインタを格納したコンテナ
 * @retval void
 */
template<class T> void ContainerFreeVector(T &cont)
{
	typename T::iterator iter;

	for (iter = cont.begin(); iter != cont.end(); ++ iter) {
		if (*iter != NULL) {
			delete [] *iter;
		}
	}
	cont.clear();
}


/*!
 * @brief 文字列から読み込んだ値を返す
 * @param string& str 文字列
 * @param T *value 値を格納する変数
 * @retval void
 */
template<class T> void InputStringValue (string& str, T *value)
{
	stringstream sstream(str);
	sstream >> *value;
}


#if 0
template <class T> void endian_swap(T *value)
{
	if (sizeof(*value) == 2) {
		ushort tmp = ((*(ushort *)value & 0xFF00) >> 8 | (*(ushort *)value & 0x00FF) << 8);
		*(ushort *)value = tmp;
	} else if (sizeof(*value) == 4) {
		uint tmp = (float) ((*(uint *)value & 0x000000FF) << 8 * 3 | (*(uint *)value & 0x0000FF00) << 8
			       | (*(uint *)value & 0x00FF0000) >> 8 | (*(uint *)value & 0xFF000000) >> 8 * 3);
		*(uint *)value = tmp;
#if 0
		cout << "hoge : " << ((*(uint *)value & 0x000000FF) << 8 * 3) << endl;
		cout << "hoge : " << ((*(uint *)value & 0x0000FF00) << 8) << endl;
		cout << "hoge : " << ((*(uint *)value & 0x00FF0000) >> 8) << endl;
		cout << "hoge : " << ((*(uint *)value & 0xFF000000) >> 8 * 3) << endl;
		cout << tmp << endl;
#endif
	}
	
}
#endif

#if 1
template <class T> void endian_swap(T *value)
{
        char *p = (char *) value;
        int size = sizeof(*value);
        for (int i = 0; 2 * i < size; ++ i) {
                swap(p[i], p[size - i - 1]);
        }
}
#endif

#if 0
/*!
 * @brief 優先度付き待ち行列を高速に使うための派生クラス
 */
template<class T> class FastPriorityQueue : public priority_queue<T, vector<T>, greater<T> > 
{
public:
	void reserve(typename vector<T>::size_type n) { c.reserve(n); }
	void clear() {
		for (; !empty(); pop());
	}
}
#endif

}
}

#endif // #ifndef _MY_TEMPLATES_
